#include <config.h>

#ident "$Id: shell.c,v 1.13 2006/01/18 19:38:27 kloczek Exp $"

#include <stdio.h>
#include <sys/wait.h>
#include <fcntl.h>
#include "prototypes.h"
#include "defines.h"

int safe_system(const char *command, const char *argv[], const char *env[], int ignore_stderr)
{
	int status = -1;
	int fd;
	pid_t pid;
	
	pid = fork();
	if (pid < 0) 
		return -1;

	if (pid) {       /* Parent */
		waitpid(pid, &status, 0);
		return status;
	}

	fd = open("/dev/null", O_RDWR);
	/* Child */
	dup2(fd,0);	// Close Stdin
	if (ignore_stderr)
		dup2(fd,2);	// Close Stderr
	
	execve(command, (char *const *) argv, (char *const *) env);
	fprintf (stderr,
		 _("Failed to exec '%s'\n"), argv[0]);
	exit (-1);
}

